!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine LatentHeat
!
!   * Developer: KITAMORI Taichi 
!   * Version: $Id: latentheat.f90,v 1.5 2011-10-25 08:24:02 yamasita Exp $
!   * Tag Name: $Name: arare4-20120511 $
!   * Change History: 
!
!== Overview 
!
! ŷ̤ŷǮ׻. 
! ̩٤̩٤ɾ. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!
!
!== Future Plans
!
                                                                 !=end
subroutine LatentHeat(xz_Masscond,         & !(in) ŷ
  &                   xz_Exner,            & !(in) ʡؿʬ
  &                   xz_PotTemp,          & !(in) ̾ʬ
  &                   xz_Qcond)              !(out) ŷǮˤ벹ѲΨ
                                                                 !=begin
  !==Dependency
  use dc_trace, only: BeginSub, EndSub  
  use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax
!  use physset,  only: GasR              ! 
!  use cloudset, only: SatPressB         ! Antoine μη B
!  use ChemData, only: ChemData_SVapPress_AntoineB, & ! Antoine μη B
!    &                 ChemData_Cp        ! ʬ갵Ǯ
  use basicset, only: xz_DensBasicZ,  &  ! ̩ٴܾ 
    &                 xz_ExnerBasicZ, &  ! ̵ϴܾ
    &                 xz_PotTempBasicZ, &  ! ̴ܾ
!    &                 ss_CpBasicZ, &    ! 갵Ǯ
    &                 GasRDry, &         ! 
    &                 CpDry, &           ! 갵Ǯ
    &                 CvDry, &           ! Ǯ
    &                 PressSfc, &        ! ɽ̰
    &                 LatHeatPerMass     ! CO2 ñ̼̤Ǯ
  use StorePotTemp, only: StorePotTempCond
                                                                 !=end
  !==ۤηػ
  implicit none
  
  !==Input
!  real(8)                :: xz_LatHeatPerMass(DimXMin:DimXMax, DimZMin:DimZMax)
!                                           ! ñ̼̤Ǯ [J/kg]
  real(8)                :: xz_Masscond(DimXMin:DimXMax, DimZMin:DimZMax) 
                                           ! ŷ [kg/m^3 s]
  real(8)                :: xz_DensAll(DimXMin:DimXMax, DimZMin:DimZMax) 
                                           ! ̩٤ [kg/m^3]
  real(8)                :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
                                           ! ʡؿʬ
  real(8)                :: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax) 
                                           ! ̾ʬ [K]

  !==Output
  real(8), intent(out)   :: xz_Qcond(DimXMin:DimXMax, DimZMin:DimZMax) 
                                           ! ŷǮˤ벹ѲΨ [K/s]
  
  !==Work

  call BeginSub("LatentHeat", &
&           fmt="%c",        &
&           c1="Calculate potential temperature tendency bylatent heating.")

  xz_DensAll = &
   & ( PressSfc / GasRDry ) &
   & * (xz_Exner + xz_ExnerBasicZ) ** (CvDry / GasRDry) &
   & / (xz_PotTemp + xz_PotTempBasicZ)

  xz_Qcond = LatHeatPerMass * xz_Masscond &
    & / (CpDry * xz_DensAll * xz_ExnerBasicZ)

  call StorePotTempCond( xz_QCond )

  call EndSub("LatentHeat")

end subroutine LatentHeat
